PAGE	50,132
TITLE	KEYBRD Version 0.1, September 1991
COMMENT	\

Takes keystrokes, waits for the laptop's buffer to empty, then
sends them out the printer port.

Version 0.1, written for January 1991 SAR
(c) 1991, BYTE/McGraw Hill
Portions (c) 1987, 1990 Overpriced Software

Version 0.1	HME	Initial code

Assemble KEYBRD.ASM under Turbo Assembler with:
	tasm /ml laptop
	tlink /x /c /t laptop
If you're running with Turbo Debugger:
	tasm /ml /la /zi laptop
	tlink /m /l /s /c /v /t laptop
	tdmap laptop.map laptop.tds
\

CODE SEGMENT PUBLIC 'CODE'

	ORG	100H

ASSUME	CS:CODE,DS:CODE,ES:NOTHING,SS:NOTHING

KEYBRD	PROC	FAR

START:	JMP	Real_start

DEBUG	equ	1		; Turns on a HEX display in the
				; upper left
PS2	equ	0		; PS/2 and compatible BIOSes have a function
				; to store data in the keyboard
				; buffer.  Older machines don't.
	if	DEBUG
SCRN_SEG	equ	0b000h	; B000 for mono, B800 for CGA->VGA
	endif
LPT1_addr	equ	0378h	; LPT1
LPT2_addr	equ	0278h	; LPT2
Mono_addr	equ	03BCh	; LPT1 on mono cards
; input bits mapped as follows (address+1)
;	3	Nybble select 0
;	4	Nybble select 1
;	5	Nybble select 2
;	7	Keys in buffer? 1=yes, 0=no
; output bits
;	bit#	function			original function
;	0	Nybble data 0			Select
;	1	Nybble data 1			Paper out
;	2	Nybble data 2			ACK
;	3	Nybble data 3			BUSY
;	4	low bit from nybble select	ERROR
;		(data return)
Data_mask	equ	0f0h	; isolate the incoming data
Data_adj	equ	080h	; XOR to adjust the data polarity
Nybble_ret	equ	008h	; isolate the nybble return
Last_nybble	db	4	; last one requested
Keyb_status_msk	equ	10000000b
switch_val	db	0	; 1=LPT1, 2=LPT2, m=LPT1 (mono)
Printer_addr	dw	LPT1_addr
hex_table	db	'0123456789ABCDEF'

ASSUME	CS:CODE,DS:CODE
;
Real_start:
; Before we start, look through the command line for a '/'.  The next
; character is the LPT port
	mov	bx,81h
cl_0:
	mov	al,[bx]
	cmp	al,13		; CR?
	je	bad_switch
	cmp	al,'/'
	je	test_char
	inc	bx		; not yet
	jmp	short cl_0
test_char:
	mov	al,[bx+1]
	cmp	al,'m'
	je	is_mono
	cmp	al,'1'
	jl	bad_switch
	cmp	al,'2'
	jg	bad_switch
	mov	switch_val,al
	mov	msg_1a,al
	sub	al,'1'			; Now, 0 or 1
; LPT1 is 378, LPT2 is 278.  Multiply AL by 100H and subtract
; from 378
	mov	cl,8
	cbw
	shl	ax,cl
	neg	ax
	add	ax,378h
	mov	Printer_addr,ax
	jmp	short printer_set
is_mono:
	mov	ax,Mono_addr
	mov	Printer_addr,ax
	jmp	short printer_set
bad_switch:
	mov	dx,offset msg_4
	mov	ah,9
	int	21h
	jmp	bye_bye

printer_set:
	mov	ah,9
	mov	dx,offset msg_1
	int	21h

main_loop:
	mov	ah,0
	int	16h		; grab a char
	mov	bx,ax		; save
	cmp	al,1bh		; ESC?
	jne	send_it
; Yes.  If ctrl was pressed too, punt.
	mov	ah,2
	int	16h
; Bit 2 in AL is set on CTRL
	test	al,00000100b
	jnz	all_done

send_it:
; scan code/ascii pair in BX	
	call	send_codes
	jmp	short main_loop
all_done:
	jmp	bye_bye
;-----------------------------------------------------------------
	if	DEBUG
disp_val	proc	near
; Convert to Ascii
	push	ax
	push	cx
	push	bx
	push	es

; High byte first. Save the low byte
	mov	cl,al
	mov	al,ah
	and	al,0f0h
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1
	mov	bx,offset hex_table
	xlat	hex_table
	xchg	al,ah
	and	al,0fh
	xlat	hex_table
; display it
	push	ax		; high nybble in AH, low in AL
	push	ax
	mov	ax,SCRN_SEG
	mov	es,ax
	pop	ax
	mov	al,ah
	mov	ah,7
	mov	word ptr es:[0],ax
	pop	ax
	mov	ah,7
	mov	word ptr es:[2],ax
; No the low byte
	mov	al,cl
	mov	ah,al
	and	al,0f0h
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1
	mov	bx,offset hex_table
	xlat	hex_table
	xchg	al,ah
	and	al,0fh
	xlat	hex_table
; display it
	push	ax		; high nybble in AH, low in AL
	push	ax
	mov	ax,SCRN_SEG
	mov	es,ax
	pop	ax
	mov	al,ah
	mov	ah,7
	mov	word ptr es:[4],ax
	pop	ax
	mov	ah,7
	mov	word ptr es:[6],ax

	pop	es
	pop	bx
	pop	cx
	pop	ax
	ret
disp_val	endp
	endif
;-----------------------------------------------------------------
PORTIN	proc	near
; Grabs a byte from the printer port
; OUTPUT:
;	AL=data byte
	mov	ax,Printer_addr
	inc	ax
	mov	dx,ax
	in	al,dx
	ret
PORTIN	endp
;-----------------------------------------------------------------
PORTOUT	proc	near
; Output a byte to the printer port
; INPUT:
;	AL=data byte
	mov	dl,al
	mov	ax,Printer_addr
	xchg	ax,dx
	out	dx,al
	ret
PORTOUT	endp
;-----------------------------------------------------------------
send_codes	proc	near
; BX contains a scan code/ascii pair.  Wait for the remote's
; keyboard buffer to empty, then send out each nybble as requested.
; We're done after we send nybble 3.

; Wait for buffer empty
sc_0:
	call	PORTIN
	test	al,Keyb_status_msk
	jz	sc_0		; not yet
sc_1:
; See which nybble they want
	call	PORTIN
; value in bits 3-5
	and	al,00111000b
	shr	al,1
	shr	al,1
	shr	al,1
	mov	ch,al		; ch holds the nybble ID

	shl	al,1
	shl	al,1
; We're going to rotate the bits 0, 4, 8 or 12 bits to the right.
; Multiply the number in AL by 4 and shift the contents of BX
; that many bits.
	mov	cl,al
	mov	ax,bx
	ror	ax,cl
	and	ax,000fh
; shift it back to the left to make room for the nybble ID
	rol	ax,1
; Now to that, add in the low bit of the nybble ID as bit 0.
	mov	ah,ch
	and	ah,1
	or	al,ah
	call	PORTOUT
sc_2:
; Wait for them to ask for a different one
	call	PORTIN
; value in bits 3-5
	mov	ah,al
	and	al,00111000b
	shr	al,1
	shr	al,1
	shr	al,1
	cmp	al,ch
	je	sc_2
; If we sent nybble 3, stop sending
	cmp	ch,3
	jne	sc_1
sc_out:
	ret
send_codes	endp
;-----------------------------------------------------------------
bye_bye:
	int	20h
;-----------------------------------------------------------------
KEYBRD		ENDP
msg_1	db	'KEYBRD V0.1 is running on LPT'
msg_1a	db	'm:',13,10
	db	'(c) 1991, BYTE/McGraw Hill',13,10
	db	'Portions (c) 1987, 1990 Overpriced Software',13,10,10
	db	'Press Ctrl-ESC to exit.',13,10,'$'
msg_4	db	'Usage: KEYBRD /port, where port=1 for LPT1:',13,10
	db	'                                2 for LPT2:',13,10
	db	'                                m for Monochrome adapter port'
	db	13,10,'$'
;
;
PROG_END	LABEL	BYTE
CODE		ENDS
	END	START		; JUMP TO START OF THE PROGRAM
